program TIGCCUninst;

uses
	Windows, Messages, SysUtils, Classes, Registry, UtilsDos, UtilsWin, ShlObj, ActiveX;

{$R *.RES}

const
	EnvRem = 'REM  Environment for TI-GCC Command-Line Compiler';

var
	InstallDir: string;
	ProgramGroup: string;
	ProgPath: array [0..MAX_PATH] of Char;
	ProgGroupPath: string;

procedure DelLink(const Link: string);
begin
	if Length (ProgGroupPath) > 0 then begin
		if FileExists (WithBackslash (ProgGroupPath) + Link + '.lnk') then try
			DeleteFile (WithBackslash (ProgGroupPath) + Link + '.lnk');
		except end else if FileExists (WithBackslash (ProgGroupPath) + Link + '.pif') then try
			DeleteFile (WithBackslash (ProgGroupPath) + Link + '.pif');
		except end;
	end;
end;

var
	GroupExisted,
	Modified: Boolean;
	RegStr,
	DosFold,
	TmpDir: string;
	L: TStringList;
	I,
	P: Integer;
	F: TSearchRec;

var
	IDList: PItemIDList;
	Malloc: IMalloc;

begin
	InstallDir := 'C:\TIGCC';
	ProgramGroup := 'TIGCC SDK';
	GroupExisted := False;
	with TRegistry.Create do try
		RootKey := HKey_Local_Machine;
		if OpenKeyReadOnly ('\Software\TIGCC Team\TIGCC') then try
			if ValueExists ('Program Folder') then
				InstallDir := ReadString ('Program Folder');
			if ValueExists ('Program Group') then
				ProgramGroup := ReadString ('Program Group');
			if ValueExists ('Program Group Existed') then
				GroupExisted := ReadBool ('Program Group Existed');
		except end;
	finally
		Free;
	end;
	if DirExists (InstallDir) then begin
		if ShowDefaultMessageBox
			('Are you sure you want to remove the folder ''' + InstallDir + ''' and all its contents?  This will not only remove the files that were installed during the setup process, but also everything you saved in this folder.',
			'Confirm Uninstall', mtQuestion, False, False, 2) = idYes then begin
			DelTree (InstallDir);
			if (Length (ProgramGroup) > 0) and (SHGetSpecialFolderLocation (0, CSIDL_PROGRAMS, IDList) = NOERROR) then try
				SHGetPathFromIDList (IDList, ProgPath);
				if SHGetMalloc (Malloc) = NOERROR then
					Malloc.Free (IDList);
				Malloc := nil;
				ProgGroupPath := WithBackslash (ProgPath) + ProgramGroup;
				if GroupExisted then begin
					DelLink ('TIGCC IDE');
					DelLink ('TIGCC Command Line Prompt');
					DelLink ('TIGCC Documentation');
					DelLink ('Uninstall TIGCC');
				end else
					DelTree (ProgGroupPath);
			except end;
			if FileExists ('C:\AUTOEXEC.BAT') then begin
				L := TStringList.Create;
				try
					try
						L.LoadFromFile ('C:\AUTOEXEC.BAT');
					except end;
					Modified := False;
					for I := L.Count - 1 downto 0 do
						if L [I] = EnvRem then begin
							Modified := True;
							L.Delete (I);
							if I < L.Count then
								L.Delete (I);
						end;
					if Modified then try
						L.SaveToFile ('C:\AUTOEXEC.BAT');
					except end;
				finally
					L.Free;
				end;
			end;
			with TRegistry.Create do try
				RootKey := HKey_Local_Machine;
				if KeyExists ('\Software\Microsoft\Windows\CurrentVersion\Uninstall\TI-GCC') then try
					DeleteKey ('\Software\Microsoft\Windows\CurrentVersion\Uninstall\TI-GCC');
				except end;
				RootKey := HKey_Classes_Root;
				if KeyExists ('\.tpr') then try
					DeleteKey ('\.tpr');
					if KeyExists ('\TIGCCProject') then
						DeleteKey ('\TIGCCProject');
				except end;
				try
					RegStr := '';
					RootKey := HKey_Local_Machine;
					if OpenKey ('\System\CurrentControlSet\Control\Session Manager\Environment', False) then begin
						DosFold := '';
						TmpDir := WithBackslash (InstallDir);
						Delete (TmpDir, Length (TmpDir), 1);
						while Length (TmpDir) > 2 do begin
							if FindFirst (TmpDir, faDirectory or faReadOnly or faHidden or faSysFile or faArchive, F) = 0 then begin
								if Length (F.FindData.cAlternateFileName) > 0 then
									DosFold := UpperCase (F.FindData.cAlternateFileName) + '\' + DosFold
								else
									DosFold := UpperCase (F.Name) + '\' + DosFold;
							end else
								DosFold := UpperCase (ExtractFileName (TmpDir)) + '\' + DosFold;
							FindClose (F);
							Delete (TmpDir, LastPos ('\', TmpDir), Length (TmpDir));
						end;
						DosFold := UpperCase (TmpDir) + '\' + DosFold;
						if Length (DosFold) > 3 then
							Delete (DosFold, Length (DosFold), 1);
						if ValueExists ('Path') then try
							RegStr := ReadString ('Path');
						except end;
						P := Pos (UpperCase (DosFold), UpperCase (RegStr));
						if P > 0 then begin
							if P > 1 then
								Dec (P);
							Delete (RegStr, P, Length (DosFold) + 1);
						end;
						try
							WriteExpandString ('Path', RegStr);
						except end;
					end;
				except end;
			finally
				Free;
			end;
			ShowDefaultMessageBox
				('The uninstallation has been completed successfully.',
				'Uninstall Complete', mtInformation);
		end;
	end else begin
		ShowDefaultMessageBox
			('TIGCC has already been removed from this system.',
			'Error', mtProgramError);
		with TRegistry.Create do try
			RootKey := HKey_Local_Machine;
			if KeyExists ('\Software\Microsoft\Windows\CurrentVersion\Uninstall\TI-GCC') then try
				DeleteKey ('\Software\Microsoft\Windows\CurrentVersion\Uninstall\TI-GCC');
			except end;
		finally
			Free;
		end;
	end;
end.
